---
title: "A VSCode extension for GitLab: GitLab Workflow"
author: Fatih Acet
author_gitlab: fatihacet
author_twitter: fatihacet
categories: engineering
image_title: '/images/blogimages/vs-code-extension-gitlab-workflow.jpg'
description: "Senior Frontend Engineer Fatih Acet created a VSCode extension, GitLab Workflow, which allows you to do many GitLab-specific tasks quickly and easily."
twitter_text: "A @code extension for @GitLab: GitLab Workflow"
tags: demo, open source, integrations
---

We recently did a survey within the Frontend team to see which tools we were using and how we were using them, in order to learn from one another and to build better workflows. Through this survey, we determined that [VSCode](https://code.visualstudio.com/) is the most used IDE within the team. This led to the idea for a GitLab extension for VSCode that could help boost productivity.

<!-- more -->

This is not a [GitLab feature](/features/) (we're actually working on building our own integrated [web IDE](https://docs.gitlab.com/ee/user/project/web_ide/)), but the extension is a quick and easy way to perform a lot of useful actions you would usually visit [GitLab.com](https://gitlab.com/) to do, directly within VSCode. Watch the demo below and read on for more about how I developed the extension.

## Demo

<!-- blank line -->
<figure class="video_container">
  <iframe src="https://www.youtube.com/embed/XcxsF0lWBhA" frameborder="0" allowfullscreen="true"> </iframe>
</figure>
<!-- blank line -->

## First iteration of GitLab Workflow

This was my first attempt at writing a VSCode extension, and I wanted to build something simple as a first iteration. I built an extension that allowed users to see issues and merge requests assigned to them on GitLab.com. The detailed documentation and powerful APIs of VSCode enabled me to build my first version in less than two hours! It was an enjoyable experience.

## Further iterations

This led to the creation of my second iteration: showing MR URLs, providing the pipeline status on the status bar, opening the current file and current MR on GitLab.com. I shared this second iteration with my fellow GitLabbers on our internal Slack and received a lot of positive feedback. After that, I released new iterations and it got more than 5,000 installations in just a month. It was so well received that it was featured on the "Trending this week" section of Visual Studio Marketplace and is still currently being featured on the "Trending this month" section 🎉

<center><img src="/images/blogimages/gitlab-vscode-extension/trending-this-month.png" alt="GitLab Workflow on Visual Studio Marketplace" style="width: 700px;"/></center>{: .shadow}

The current version of this extension allows you to:

- See pipeline status, open MR and close issue links in the status bar. [Read more](https://gitlab.com/fatihacet/gitlab-vscode-extension/tree/master#status-bar).
- Automatically update pipeline status on the status bar so you don't need to open GitLab to see your pipeline status.
- Advanced pipeline actions allow you to view a pipeline on GitLab, create a new pipeline, and retry or cancel current pipeline. [Read more](https://gitlab.com/fatihacet/gitlab-vscode-extension/tree/master#pipeline-actions).
- Issue and MR search including simple and advanced search. [Read more](https://gitlab.com/fatihacet/gitlab-vscode-extension/tree/master#advanced-search).
- View an MR and close an issue on GitLab with a single click from your status bar.
- View an active file on GitLab with highlighting active line number and selected text block. [Read more](https://gitlab.com/fatihacet/gitlab-vscode-extension/tree/master#open-active-file).
- Create public, internal or private snippet from entire file or selection. [Read more](https://gitlab.com/fatihacet/gitlab-vscode-extension/tree/master#create-snippet).
- Compare your branch with master and view changes on GitLab. [Read more](https://gitlab.com/fatihacet/gitlab-vscode-extension/tree/master#compare-with-master).
- Validate GitLab CI configuration file `.gitlab-ci.yml`. [Read more](https://gitlab.com/fatihacet/gitlab-vscode-extension/tree/master#validate-gitlab-ci-configuration).

See below for more tasks you can perform quickly with the extension.

<center><img src="/images/blogimages/gitlab-vscode-extension/gitlab-vscode.png" alt="GitLab Workflow Commands" style="width: 700px;"/></center>{: .shadow}

You can find the source code [here](https://gitlab.com/fatihacet/gitlab-vscode-extension) and see the extension [on marketplace](https://marketplace.visualstudio.com/items?itemName=fatihacet.gitlab-workflow). You can read the documentation [here](https://gitlab.com/fatihacet/gitlab-vscode-extension/blob/master/README.md) and check the CHANGELOG [here](https://gitlab.com/fatihacet/gitlab-vscode-extension/blob/master/CHANGELOG.md). There is also a [Product Hunt page](https://www.producthunt.com/posts/gitlab-workflow) for the extension.

Photo by [Iker Urteaga](https://unsplash.com/photos/TL5Vy1IM-uA?utm_source=unsplash&utm_medium=referral&utm_content=creditCopyText) on [Unsplash](https://unsplash.com/search/photos/tools?utm_source=unsplash&utm_medium=referral&utm_content=creditCopyText)
{: .note}
